<?xml version="1.0" encoding="UTF-8"?>
<?eclipse version="3.4"?>
<plugin>
	<!-- Project nature definition -->
	<!-- Note: the actual id is <pluginID>.<natureID>, ie. CaseineVPL.caseineNature -->
	<extension
		id="caseineNature"
		name="Caseine Project Nature"
		point="org.eclipse.core.resources.natures">
		<runtime>
			<run class="caseine.vpl.nature.CaseineNature"/>
		</runtime>
	</extension>
	
	<extension point="org.eclipse.ui.propertyPages">
		<page
			id="caseine.vpl.properties.caseinePropertyPage"
			class="caseine.vpl.properties.CaseinePropertyPage"
			name="Caseine">
			<enabledWhen>
				<adapt type="org.eclipse.core.resources.IProject">
					<test
						property="org.eclipse.core.resources.projectNature"
						value="CaseineVPL.caseineNature">
					</test>
				</adapt>
			</enabledWhen>
		</page>
	</extension>
	<extension point="org.eclipse.ui.preferencePages">
		<page
			id="caseine.vpl.preferences.CaseinePreferencePage"
			class="caseine.vpl.preferences.CaseinePreferencePage"
			name="Caseine">
		</page>
	</extension>
	<extension point="org.eclipse.core.runtime.preferences">
		<initializer class="caseine.vpl.preferences.PreferenceInitializer"/>
	</extension>
	
	<!-- Commands definitions -->
	<extension point="org.eclipse.ui.commands">
		<category
			id="caseine.vpl.commands.category"
			name="menu">
		</category>
		<command
			id="caseine.vpl.commands.pull"
			name="pull"
			description="project import"
			defaultHandler="caseine.vpl.handlers.PullProjectHandler"
			categoryId="caseine.vpl.commands.category">
		</command>
		<command
			id="caseine.vpl.commands.push"
			name="push"
			description="project export"
			defaultHandler="caseine.vpl.handlers.PushProjectHandler"
			categoryId="caseine.vpl.commands.category">
		</command>
		<command
			id="caseine.vpl.commands.reset"
			name="reset"
			description="project import"
			defaultHandler="caseine.vpl.handlers.ResetProjectHandler"
			categoryId="caseine.vpl.commands.category">
		</command>
		<command
			id="caseine.vpl.commands.evaluate"
			name="evaluate"
			description="project evaluation"
			defaultHandler="caseine.vpl.handlers.EvaluateProjectHandler"
			categoryId="caseine.vpl.commands.category">
		</command>
		<command
			id="caseine.vpl.commands.addGILib"
			name="addGIlibs"
			defaultHandler="caseine.vpl.handlers.AddGILibrariesHandler"
			categoryId="caseine.vpl.commands.category">
		</command>
		
		<command
			id="caseine.vpl.commands.toggleNature"
			name="toggleNature"
			defaultHandler="caseine.vpl.nature.AddRemoveCaseineNatureHandler">
		</command>
	</extension>
	
	<!-- mettre le menu contextuel dans les bons endroits  -->
	<extension point="org.eclipse.ui.menus"> 
		<menuContribution locationURI="popup:org.eclipse.ui.popup.any?after=additions"> 
			<menu
				id="caseine.vpl.menu"
				label="CaseInE"
				icon="icons/caseine.png">
				<visibleWhen>
					<with variable="selection">
						<count value="1"/>
						<iterate>
							<adapt type="org.eclipse.core.resources.IResource">
								<test
									property="org.eclipse.core.resources.projectNature"
									value="CaseineVPL.caseineNature">
								</test>
							</adapt>
						</iterate>
					</with>
				</visibleWhen>
				<command
					commandId="caseine.vpl.commands.reset"
					label="Reset"
					tooltip="Reset project to initial VPL state"
					icon="icons/reset.png">
				</command>
				<command
					commandId="caseine.vpl.commands.pull"
					label="Pull"
					tooltip="Pull (import) project from current VPL state"
					icon="icons/caseine_arrow_pull.png">
				</command>
				<command
					commandId="caseine.vpl.commands.push"
					label="Push"
					tooltip="Push (export) project to VPL"
					icon="icons/caseine_arrow_push.png">
				</command>
				<command
					commandId="caseine.vpl.commands.evaluate"
					label="Evaluate"
					tooltip="Evaluate project"
					icon="icons/evaluate.png">
				</command>
				<separator
					name="separator-id"
					visible="true">
				</separator>
				<command
					commandId="caseine.vpl.commands.addGILib"
					label="Add GI libraries"
					tooltip="Add GI libraries to this project"
					icon="icons/add_GI_libraries.png">
				</command>
			</menu>
		</menuContribution>
		<menuContribution locationURI="popup:org.eclipse.ui.projectConfigure?after=additions">
			<command
				commandId="caseine.vpl.commands.toggleNature"
				label="Disable Caseine">
				<visibleWhen checkEnabled="false">
					<with variable="selection">
						<count value="1"/>
						<iterate>
							<adapt type="org.eclipse.core.resources.IProject">
								<test
									property="org.eclipse.core.resources.projectNature"
									value="CaseineVPL.caseineNature">
								</test>
							</adapt>
						</iterate>
					</with>
				</visibleWhen>
			</command>
			<command
				commandId="caseine.vpl.commands.toggleNature"
				label="Enable Caseine">
				<visibleWhen checkEnabled="false">
					<with variable="selection">
						<count value="1"/>
						<iterate>
							<adapt type="org.eclipse.core.resources.IProject">
								<not>
									<test
										property="org.eclipse.core.resources.projectNature"
										value="CaseineVPL.caseineNature">
									</test>
								</not>
							</adapt>
						</iterate>
					</with>
				</visibleWhen>
			</command>
		</menuContribution>
		<menuContribution locationURI="toolbar:org.eclipse.ui.main.toolbar?after=additions">
			<toolbar id="caseine.vpl.toolbar">
				<command
					commandId="caseine.vpl.commands.push"
					id="caseine.vpl.toolbarcommands.push"
					icon="icons/caseine_arrow_push.png"
					tooltip="Push">
					<visibleWhen checkEnabled="false">
						<with variable="activeWorkbenchWindow.activePerspective">
							<or>
								<equals value="caseine.vpl.perspectives.java"/>
								<equals value="caseine.vpl.perspectives.python"/>
							</or>
						</with>
					</visibleWhen>
				</command>
				<command
					commandId="caseine.vpl.commands.evaluate"
					id="caseine.vpl.toolbarcommands.evaluate"
					icon="icons/evaluate.png"
					tooltip="Evaluate">
					<visibleWhen checkEnabled="false">
						<with variable="activeWorkbenchWindow.activePerspective">
							<or>
								<equals value="caseine.vpl.perspectives.java"/>
								<equals value="caseine.vpl.perspectives.python"/>
							</or>
						</with>
					</visibleWhen>
				</command>
			</toolbar>
		</menuContribution>
	</extension>
	
	<!-- Project Decorator (class ProjectDecorator) -->
	<extension point="org.eclipse.ui.decorators">
		<decorator
			id="caseine.vpl.decorator"
			class="caseine.vpl.decorators.ProjectDecorator"
			label="Caseine Decorator"
			adaptable="true"
			state="true">
			<enablement>
				<objectClass name="org.eclipse.core.resources.IProject"/>
			</enablement>
		</decorator>
	</extension>

	<!-- Wizard : Caseine Project (class CaseineProjectWizard) -->
	<extension point="org.eclipse.ui.newWizards">
		<category
			id="caseineWizards"
			name="Caseine Wizards">
		</category>
		<wizard
			id="caseine.wizard.CaseineProjectWizard"
			class="caseine.vpl.wizard.CaseineProjectWizard"
			name="Caseine Project"
			icon="icons/caseine.png"
			category="caseineWizards"
			project="true">
		</wizard>
	</extension>

	<!-- Views : Caseine View (class VplView) , Caseine Comments (class CommentsView) -->
	<extension point="org.eclipse.ui.views">
		<category
			id="caseine.vpl.views"
			name="Caseine">
		</category>
		<!-- CaseInE View (class VplView) -->
		<view
			id="caseine.vpl.vplview"
			class="caseine.vpl.views.vplview.VplView"
			name="Caseine View"
			icon="icons/caseine.png"
			category="caseine.vpl.views">
		</view>
		<!-- Caseine Comments (class CommentsView) -->
		<view
			id="caseine.vpl.commentsview"
			class="caseine.vpl.views.commentsview.CommentsView"
			name="Caseine Comments"
			icon="icons/caseine_comment.png"
			category="caseine.vpl.views">
		</view>
	</extension>

	<!-- Duplicate Java Perspective and add our views -->
	<extension point="org.eclipse.ui.perspectives">
		<perspective
			id="caseine.vpl.perspectives.java"
			name="Caseine Java"
			class="org.eclipse.jdt.internal.ui.JavaPerspectiveFactory"
			icon="icons/caseine_java.png">
		</perspective>
		<perspective
			id="caseine.vpl.perspectives.python"
			name="Caseine Python"
			class="caseine.vpl.perspectives.PythonPerspective"
			icon="icons/caseine_python.png">
		</perspective>
	</extension>
	<extension point="org.eclipse.ui.perspectiveExtensions">
		<perspectiveExtension targetID="caseine.vpl.perspectives.java">
			<viewShortcut id="caseine.vpl.vplview"/>
			<viewShortcut id="caseine.vpl.commentsview"/>
			<newWizardShortcut id="caseine.wizard.CaseineProjectWizard"/>
			<view
				id="caseine.vpl.vplview"
				relative="org.eclipse.ui.views.ContentOutline"
				relationship="stack">
			</view>
			<view
				id="caseine.vpl.commentsview"
				relative="org.eclipse.ui.console.ConsoleView"
				relationship="stack">
			</view>
        </perspectiveExtension>
		<perspectiveExtension targetID="caseine.vpl.perspectives.python">
			<viewShortcut id="caseine.vpl.vplview"/>
			<viewShortcut id="caseine.vpl.commentsview"/>
			<newWizardShortcut id="caseine.wizard.CaseineProjectWizard"/>
			<view
				id="caseine.vpl.vplview"
				relative="org.eclipse.ui.views.ContentOutline"
				relationship="stack">
			</view>
			<view
				id="caseine.vpl.commentsview"
				relative="org.eclipse.ui.console.ConsoleView"
				relationship="stack">
			</view>
        </perspectiveExtension>
    </extension>

	<!-- BEGIN Markers BEGIN -->
	<extension
		id="caseine.comment.marker"
		name="CaseInE Comment"
		point="org.eclipse.core.resources.markers">
		<super type="org.eclipse.core.resources.textmarker"/>
		<super type="org.eclipse.core.resources.marker"/>
		<persistent value="false"/>
	</extension>
	<extension point="org.eclipse.ui.editors.annotationTypes">
		<type
			super="org.eclipse.ui.workbench.texteditor.info"
			markerType="caseine.comment.marker"
			name="caseine.comment.annotation">
		</type>
	</extension>
	<extension point="org.eclipse.ui.editors.markerAnnotationSpecification">
		<specification
			annotationType="caseine.comment.annotation"
			colorPreferenceKey="caseine.comment.color"
			colorPreferenceValue="255,153,255"
			contributesToHeader="false"
			highlightPreferenceKey="caseine.comment.highlight"
			highlightPreferenceValue="true"
			includeOnPreferencePage="true"
			label="CaseInE Comment"
			icon="icons/laitcaseine.png"
			overviewRulerPreferenceKey="caseine.comment.overview"
			overviewRulerPreferenceValue="true"
			presentationLayer="0"
			textPreferenceKey="caseine.comment.text"
			textPreferenceValue="true"
			textStylePreferenceValue="BOX"
			verticalRulerPreferenceKey="caseine.comment.ruler"
			verticalRulerPreferenceValue="true">
		</specification>
	</extension>
	<extension point="org.eclipse.ui.ide.markerSupport">
		<markerContentGenerator
			id="caseine.vpl.customMarkerGenerator"
			name="CaseInE Marker View">
			<markerTypeReference id="caseine.comment.marker"/>
			<markerFieldReference id="caseine.vpl.project.name"/>
			<markerFieldReference id="caseine.vpl.location"/>
			<markerFieldReference id="caseine.vpl.message"/>
		</markerContentGenerator>
		<markerField
			id="caseine.vpl.project.name"
			class="caseine.vpl.views.commentsview.ProjectNameItem"
			name="Project">
		</markerField>
		<markerField
			id="caseine.vpl.location"
			class="caseine.vpl.views.commentsview.LocationItem"
			name="Location">
		</markerField>
		<markerField
			id="caseine.vpl.message"
			class="caseine.vpl.views.commentsview.MessageItem"
			name="Message">
		</markerField>
	</extension>

 </plugin>
